/** @file twsgen_ggo.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.22.6
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef TWSGEN_GGO_H
#define TWSGEN_GGO_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef CMDLINE_PARSER_PACKAGE
/** @brief the program name (used for printing errors) */
#define CMDLINE_PARSER_PACKAGE "twsgen"
#endif

#ifndef CMDLINE_PARSER_PACKAGE_NAME
/** @brief the complete program name (used for help and version) */
#define CMDLINE_PARSER_PACKAGE_NAME "twsgen"
#endif

#ifndef CMDLINE_PARSER_VERSION
/** @brief the program version */
#define CMDLINE_PARSER_VERSION VERSION
#endif

/** @brief Where the command line options are stored */
struct gengetopt_args_info
{
  const char *verbose_xml_help; /**< @brief Never skip xml default values. help description.  */
  const char *histjob_help; /**< @brief Generate hist job. help description.  */
  char * endDateTime_arg;	/**< @brief Query end date time, default is \"\" which means now..  */
  char * endDateTime_orig;	/**< @brief Query end date time, default is \"\" which means now. original value given at command line.  */
  const char *endDateTime_help; /**< @brief Query end date time, default is \"\" which means now. help description.  */
  char * durationStr_arg;	/**< @brief Query duration, default is maximum dependent on bar size..  */
  char * durationStr_orig;	/**< @brief Query duration, default is maximum dependent on bar size. original value given at command line.  */
  const char *durationStr_help; /**< @brief Query duration, default is maximum dependent on bar size. help description.  */
  char * barSizeSetting_arg;	/**< @brief Size of the bars, default is \"1 hour\"..  */
  char * barSizeSetting_orig;	/**< @brief Size of the bars, default is \"1 hour\". original value given at command line.  */
  const char *barSizeSetting_help; /**< @brief Size of the bars, default is \"1 hour\". help description.  */
  char * whatToShow_arg;	/**< @brief List of data types, valid types are: TRADES, BID, ASK, etc., default: TRADES.  */
  char * whatToShow_orig;	/**< @brief List of data types, valid types are: TRADES, BID, ASK, etc., default: TRADES original value given at command line.  */
  const char *whatToShow_help; /**< @brief List of data types, valid types are: TRADES, BID, ASK, etc., default: TRADES help description.  */
  const char *useRTH_help; /**< @brief Return only data within regular trading hours (useRTH=1). help description.  */
  const char *utc_help; /**< @brief Dates are returned as seconds since unix epoch (formatDate=2). help description.  */
  char * includeExpired_arg;	/**< @brief How to set includeExpired, valid args: auto, always, never, keep. Default is auto (dependent on secType)..  */
  char * includeExpired_orig;	/**< @brief How to set includeExpired, valid args: auto, always, never, keep. Default is auto (dependent on secType). original value given at command line.  */
  const char *includeExpired_help; /**< @brief How to set includeExpired, valid args: auto, always, never, keep. Default is auto (dependent on secType). help description.  */
  const char *to_csv_help; /**< @brief Just convert xml to csv. help description.  */
  const char *no_conv_help; /**< @brief For testing, output xml again. help description.  */
  char * max_expiry_arg;	/**< @brief Filter out expiries newer than that..  */
  char * max_expiry_orig;	/**< @brief Filter out expiries newer than that. original value given at command line.  */
  const char *max_expiry_help; /**< @brief Filter out expiries newer than that. help description.  */
  const char *help_help; /**< @brief Show this help message. help description.  */
  const char *version_help; /**< @brief Print version string and exit. help description.  */
  const char *usage_help; /**< @brief Display brief usage message. help description.  */
  
  unsigned int verbose_xml_given ;	/**< @brief Whether verbose-xml was given.  */
  unsigned int histjob_given ;	/**< @brief Whether histjob was given.  */
  unsigned int endDateTime_given ;	/**< @brief Whether endDateTime was given.  */
  unsigned int durationStr_given ;	/**< @brief Whether durationStr was given.  */
  unsigned int barSizeSetting_given ;	/**< @brief Whether barSizeSetting was given.  */
  unsigned int whatToShow_given ;	/**< @brief Whether whatToShow was given.  */
  unsigned int useRTH_given ;	/**< @brief Whether useRTH was given.  */
  unsigned int utc_given ;	/**< @brief Whether utc was given.  */
  unsigned int includeExpired_given ;	/**< @brief Whether includeExpired was given.  */
  unsigned int to_csv_given ;	/**< @brief Whether to-csv was given.  */
  unsigned int no_conv_given ;	/**< @brief Whether no-conv was given.  */
  unsigned int max_expiry_given ;	/**< @brief Whether max-expiry was given.  */
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int usage_given ;	/**< @brief Whether usage was given.  */

  char **inputs ; /**< @brief unamed options (options without names) */
  unsigned inputs_num ; /**< @brief unamed options number */
} ;

/** @brief The additional parameters to pass to parser functions */
struct cmdline_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure gengetopt_args_info (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure gengetopt_args_info (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *gengetopt_args_info_purpose;
/** @brief the usage string of the program */
extern const char *gengetopt_args_info_usage;
/** @brief the description string of the program */
extern const char *gengetopt_args_info_description;
/** @brief all the lines making the help output */
extern const char *gengetopt_args_info_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser (int argc, char **argv,
  struct gengetopt_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use cmdline_parser_ext() instead
 */
int cmdline_parser2 (int argc, char **argv,
  struct gengetopt_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_ext (int argc, char **argv,
  struct gengetopt_args_info *args_info,
  struct cmdline_parser_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_dump(FILE *outfile,
  struct gengetopt_args_info *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_file_save(const char *filename,
  struct gengetopt_args_info *args_info);

/**
 * Print the help
 */
void cmdline_parser_print_help(void);
/**
 * Print the version
 */
void cmdline_parser_print_version(void);

/**
 * Initializes all the fields a cmdline_parser_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void cmdline_parser_params_init(struct cmdline_parser_params *params);

/**
 * Allocates dynamically a cmdline_parser_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized cmdline_parser_params structure
 */
struct cmdline_parser_params *cmdline_parser_params_create(void);

/**
 * Initializes the passed gengetopt_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void cmdline_parser_init (struct gengetopt_args_info *args_info);
/**
 * Deallocates the string fields of the gengetopt_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void cmdline_parser_free (struct gengetopt_args_info *args_info);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int cmdline_parser_required (struct gengetopt_args_info *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* TWSGEN_GGO_H */
